package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TipoEventoExtraDAO;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;

@Repository("tipoEventoExtraDAO")
public class TipoEventoExtraHibernateDAO extends
		GenericHibernateDAO<TipoEventoExtra, Integer> implements
		TipoEventoExtraDAO {

	@Autowired
	public TipoEventoExtraHibernateDAO(
			@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<TipoEventoExtra> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public List<TipoEventoExtra> buscar(String nombIngreso) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("descTipoEvento", nombIngreso));

		return c.list();
	}
	
	@Override
	public List<TipoEventoExtra> buscarLike(String nombIngreso) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.like("descTipoEvento", nombIngreso, MatchMode.ANYWHERE));

		return c.list();
	}
}
